# -*- coding: utf-8 -*-
"""Happiness_Report.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1hcC1p_P8kgoyvxVJIJgFnsS5AeZh8IXG
"""


import pandas as pd
import numpy as np
import psycopg2
import seaborn as sns

# Import all models
from pyod.models.abod import ABOD
from pyod.models.cblof import CBLOF
from pyod.models.feature_bagging import FeatureBagging
from pyod.models.hbos import HBOS
from pyod.models.iforest import IForest
from pyod.models.knn import KNN
from pyod.models.lof import LOF
from pyod.models.mcd import MCD
from pyod.models.ocsvm import OCSVM
from pyod.models.pca import PCA
from pyod.models.lscp import LSCP
from pyod.models.suod import SUOD
from pyod.models.suod import LOF
from pyod.models.suod import COPOD
from pyod.models.suod import IForest

import missingno as msno
from fancyimpute import IterativeImputer
import matplotlib.pyplot as plt


def trusted_zone_happiness():

    conn = psycopg2.connect(
        host="localhost",
        database="postgres",
        user="postgres",
        password="ADSDB")
    cursor=conn.cursor()

    cursor.execute("SELECT * FROM public.happiness_report_source20220103")
    data=cursor.fetchall()
    query="select c.column_name from information_schema.columns c where table_catalog='postgres' and table_schema='public' and table_name='happiness_report_source20220103'"
    cursor.execute(query)
    def tu(tupla):
        return tupla[0]
    columns=cursor.fetchall()
    columns=list(map(tu,columns))

    df1=pd.DataFrame(data, columns=columns)

    df1=df1.replace(10000000.00,np.nan)

    df1=df1.drop(columns='Unnamed: 0')



    """With this profiling we can observe that 25.6% of the observations are missing. However, we could identify that those missings are concentrated mainly in some variables. As those variables are not representative and not meaningfull to interpret our dataframe, we decided to drop them. The threshold stablished is at 20% of missings, thus we eliminated:
    - "GINI index (World Bank estimate)" -  1133 (61.3%) missings
    - "gini of household income reported in Gallup, by wp5-year" - 370 (20.0%) missings
    - "Most people can be trusted, Gallup" - 1668 (90.3%) missings
    - "Most people can be trusted, WVS round 1981-1984" - 1712 (92.6%) missings
    - "Most people can be trusted, WVS round 1989-1993" - 1611 (87.2%) missings
    - "Most people can be trusted, WVS round 1994-1998" - 1181 (63.9%) missings
    - "Most people can be trusted, WVS round 1999-2004" - 1319 (71.4%) missings
    - "Most people can be trusted, WVS round 2005-2009" - 1164 (63.0%) missings
    - "Most people can be trusted, WVS round 2010-2014" - 1124 (60.8%) missings
    
    We also decided to remove those variables that represent statistics already calculated, such as:
    - "Standard deviation of ladder by country-year", 
    - "Standard deviation/Mean of ladder by country-year". 
    
    Then, from the 26 original variables, we dropped 11 and maintain 15.
    """

    df1 = df1.drop(columns=[
              'GINI index (World Bank estimate)',
              'gini of household income reported in Gallup, by wp5-year',
              'Most people can be trusted, Gallup',
              'Most people can be trusted, WVS round 1981-1984',
              'Most people can be trusted, WVS round 1989-1993',
              'Most people can be trusted, WVS round 1994-1998',
              'Most people can be trusted, WVS round 1999-2004',
              'Most people can be trusted, WVS round 2005-2009',
              'Most people can be trusted, WVS round 2010-2014',
              'Standard deviation of ladder by country-year',
              'Standard deviation/Mean of ladder by country-year'
              ])



    """# **Univariate Outliers:**
    Variables with no outliers: 
    
    1. Life Ladder,
    2. Log GDP per capita,
    3. Democratic Quality,
    4. Delivery Quality.
    
    We found 19 Severe outliers which will be considered as missing values
    
    """

    # Commented out IPython magic to ensure Python compatibility.
    # %matplotlib inline

    year=df1['Year']
    country=df1['Country Name']
    X=df1.drop(columns=['Year', 'Country Name'])

    """First approach with **Boxplot**"""

    ax=sns.boxplot(data=X, orient="h", palette='Set2')

    def tukeys_method(df, variable):
        #Takes two parameters: dataframe & variable of interest as string
        q1 = df[variable].quantile(0.25)
        q3 = df[variable].quantile(0.75)
        iqr = q3-q1
        inner_fence = 1.5*iqr
        outer_fence = 3*iqr

        #inner fence lower and upper end
        inner_fence_le = q1-inner_fence
        inner_fence_ue = q3+inner_fence

        #outer fence lower and upper end
        outer_fence_le = q1-outer_fence
        outer_fence_ue = q3+outer_fence

        outliers_prob = []
        outliers_poss = []
        for index, x in enumerate(df[variable]):
            if x <= outer_fence_le or x >= outer_fence_ue:
                outliers_prob.append(index)
        for index, x in enumerate(df[variable]):
            if x <= inner_fence_le or x >= inner_fence_ue:
                outliers_poss.append(index)
        return outliers_prob, outliers_poss

    X_=X.drop(columns=['Life Ladder', 'Log GDP per capita', 'Democratic Quality', 'Delivery Quality'])
    uni_outliers={}
    for column in X_.columns:
      severe, mild = tukeys_method(X_, column)
      uni_outliers.update({column:{"Severe":len(severe), "Mild":len(mild)}})
      X[column][severe]=np.nan

    uni_outliers=pd.DataFrame(uni_outliers)
    uni_outliers





    X.insert(0, 'Country Name', country)
    X.insert(1, 'Year', year)

    X=X.drop_duplicates()

    """# **Imputation missing values**
    First, we explored the data missingness in order to see if there's some pattern in the missing values. We conclude that our data is not Missing at random in every variable. We can observe a total correlation between 'Democratic Quality' and ' Delivery Quality', also between 'Possitive affect' and 'Negative affect' and those two with 'Social support'.
    """


    sns.set(rc = {'figure.figsize':(15,6)})



    """# **MICE Imputation**"""

    X=X.drop(columns=['Year', 'Country Name'])

    mice_imputer=IterativeImputer()
    df1_imputed=mice_imputer.fit_transform(X)
    X_imputed=pd.DataFrame(df1_imputed, columns=X.columns)




    """# **Multivariate outliers using Pyod:**
    SUOD method with majority vote is used with different algorithms in order to detect multivariate outliers. After detecting them we eliminated them.
    """



    random_state = np.random.RandomState(42)

    # initialized a group of outlier detectors for acceleration
    detector_list = [LOF(n_neighbors=15), LOF(n_neighbors=20),
                     LOF(n_neighbors=25), LOF(n_neighbors=35),
                     KNN(), KNN(method='mean'),
                     COPOD(), IForest(n_estimators=100),MCD(random_state=random_state),PCA(random_state=random_state),
                     IForest(n_estimators=200), FeatureBagging(LOF(n_neighbors=35),
                           random_state=random_state), IForest(random_state=random_state), IForest(random_state=random_state)]

    # decide the number of parallel process, and the combination method
    # then clf can be used as any outlier detection model
    clf_suod = SUOD(base_estimators=detector_list, n_jobs=2, combination='majority Vote',
               verbose=False)
    clf_suod.fit(X_imputed)
    outilers=clf_suod.predict(X_imputed)
    sum(outilers)

    X_imputed['outliers']=outilers
    df1=X_imputed.drop(X_imputed[X_imputed['outliers']==1].index)
    df1.insert(0, 'Country Name', country)
    df1.insert(1, 'Year', year)
    df1=df1.reset_index()
    df1=df1.drop(columns='outliers')
    df1=df1.drop(columns=['index'])


    conn = psycopg2.connect(
        host="localhost",
        database="postgres",
        user="postgres",
        password="ADSDB")

    tpls = [tuple(x) for x in df1.to_numpy()]
    cols = '" ,"'.join(list(df1.columns))
    cols='"'+cols+'"'
    for i in range(len(tpls)):
      query="INSERT INTO {0}({1}) VALUES ("
      query  = query.format("public.happiness_report_source20220123", cols)
      tupla=list(tpls[i])

      tupla[0]="'"+tupla[0]+"'"
      tupla[1]="'"+str(tupla[1])+"'"
      tupla=tuple(tupla)
      for index, v in enumerate(tupla) :
        if index==len(tupla)-1:
          break
        query=query+str(v)+', '
      query=query+str(tupla[len(tupla)-1])+')'
      cursor.execute(query)
      print(tupla[0]+" inserted")
    conn.commit()

    cursor.execute('ROLLBACK;')

